package com.bergerkiller.bukkit.nolagg;

import net.minecraft.server.Entity;
import net.minecraft.server.EntityTNTPrimed;
import net.minecraft.server.Explosion;

import org.bukkit.craftbukkit.entity.CraftEntity;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.entity.ExplosionPrimeEvent;
import org.bukkit.event.world.ChunkUnloadEvent;

import com.all.bukkit.threadcheck.ThreadCheck;
import com.bergerkiller.bukkit.nolagg.meta.ChunkMetaData;
import com.bergerkiller.bukkit.nolagg.meta.WorldMetaData;

public class NLMonitoredListener implements Listener {
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onExplosionPrime(ExplosionPrimeEvent event) {
		if (!NoLagg.bufferTNT) return;
		if (event.isCancelled()) return;
		if (event.getEntity() == null) return;
		Entity entity = ((CraftEntity) event.getEntity()).getHandle();
		if (entity == null) return;
		if (entity instanceof EntityTNTPrimed) {
			event.setCancelled(true);
			//do stuff	
			CustomExplosion explosion = new CustomExplosion(entity.world, entity, entity.locX, entity.locY, entity.locZ, event.getRadius(), event.getFire());
	        explosion.doAll();
		}
	}
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onEntityExplode(EntityExplodeEvent event) {
		if (!ThreadCheck.check("")) return;
		if (!NoLagg.bufferTNT) return;
		if (!event.isCancelled()) {
			if (TnTHandler.createExplosion(event)) {
				//I know, we monitor, but the end result is the same anyway!
				event.setCancelled(true);
			}
		}
	}
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onChunkUnload(ChunkUnloadEvent event) {
		if (event.isCancelled()) {
			ChunkMetaData.get(event.getChunk()).markNotUnloadable();
		} else {
			WorldMetaData.get(event.getWorld()).removeChunk(event.getChunk().getX(), event.getChunk().getZ());
			NLListener.unloadedChunks++;
		}
	}
	
}
