package com.bergerkiller.bukkit.nolagg.saving;

import java.lang.reflect.Field;

import net.minecraft.server.ServerConfigurationManager;
import net.minecraft.server.WorldServer;

import org.bukkit.World;

import com.bergerkiller.bukkit.common.Task;
import com.bergerkiller.bukkit.nolagg.ChunkHandler;
import com.bergerkiller.bukkit.nolagg.NoLagg;
import com.bergerkiller.bukkit.nolagg.Util;

public class AutoSaveChanger {
	private static Field saveInterval;
	private static final int defaultInterval = 40;
	public static int newInterval;
	private static Task autoSaveTask;
		
	private static boolean validate(String fieldname) {
		try {
			saveInterval = net.minecraft.server.World.class.getDeclaredField(fieldname);
			if (saveInterval.getType() == int.class) {
				saveInterval.setAccessible(true);
				return true;
			}
		} catch (NoSuchFieldException ex) {
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		saveInterval = null;
		return false;
	}
	
	public static void init() {
		if (validate("u") || validate("p")) {
			if (newInterval > 400) {
				autoSaveTask = new Task(NoLagg.plugin) {
					public void run() {
						ServerConfigurationManager scm = Util.getMCServer().serverConfigurationManager;
						if (scm != null) scm.savePlayers();
						for (WorldServer world : Util.getWorlds()) {
							world.saveLevel();
						}
					}
				}.start(newInterval, newInterval);
				newInterval = Integer.MAX_VALUE;
			} else if (newInterval <= 10) {
				newInterval = defaultInterval;
			}
		} else {
			System.out.println("[NoLagg] Failed to bind to the field to enable Auto-save interval changer!");
		}
	}
	public static void deinit() {
		newInterval = defaultInterval;
		if (saveInterval != null) {
			changeAll();
		}
		saveInterval = null;
		Task.stop(autoSaveTask);
	}
	
	public static void change(WorldServer world) {
		if (saveInterval != null) {
			try {
				saveInterval.setInt(world, newInterval);
			} catch (Exception e) {
				System.out.println("[NoLagg] Failed to set save interval on world: " + world.getWorld().getName());
				e.printStackTrace();
			}
		}
	}
	
	public static void change(World world) {
		change(ChunkHandler.getNative(world));
	}
	
    public static void changeAll() {
    	for (WorldServer world : Util.getWorlds()) {
    		change(world);
    	}
	}

}
